/* eslint-disable no-unused-expressions */
/* eslint-disable no-undef */

let gaInit = false;
const ua = navigator.userAgent.toLowerCase();
const uaBrowser =
  ua.indexOf("firefox") > -1 ? "Firefox" : window.safari ? "Safari" : "Chrome";

if (uaBrowser === "Chrome") {
  // prettier-ignore
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
} else {
  var ga = () => {};
}

if (chrome.runtime.id === "ioepikcpapgjopobjcgjcfeejddafjbm") {
} else {
  let pings = {};
  let nativePort = null;
  let lastNativeMsg = 0;
  let connectedPorts = [];
  let connectedPagePorts = [];
  let installFamilyCache = {};

  const systemGrey1 = "#8E8E93";
  const systemGrey2 = "#636366";
  const systemGrey3 = "#48484A";
  const systemGrey4 = "#3A3A3C";
  const systemGrey5 = "#2C2C2E";
  const systemGrey6 = "#121212";
  const customLightGrey = "#B1B1B9";
  const ninjaGreenLight = "#00CA99";
  const ninjaGreenMiddle = "#268F76";
  const ninjaGreenDark = "#0D6051";

  const createNativePort = () => {
    if (nativePort) return;
    try {
      nativePort = chrome.runtime.connectNative("fonts.ninja.app");
    } catch (err) {
      return;
    }
    if (!nativePort) return;
    nativePort.onDisconnect.addListener(() => {
      nativePort = null;
    });

    nativePort.onMessage.addListener((msg) => {
      if (msg.id === "fonts.ninja.app") {
        Object.entries(installFamilyCache).forEach(
          ([fontFamily, suggestionFamily]) => {
            msg = {
              id: "fonts.ninja.ext.proxy",
              type: "installFamily",
              fontFamily,
              suggestionFamily,
            };
            if (!msg.type.match(/^p.ng$/) || msg.index < 10)
              console.log("ext>app", msg);
            nativePort.postMessage(msg);
          }
        );
        installFamilyCache = {};
        lastNativeMsg = new Date().getTime();
      }
      msg = Object.assign({ id: "fonts.ninja.ext.proxy" }, msg);
      if (msg.type !== "pong") {
        try {
          // chrome.tabs.sendMessage(tab.id, msg);
          connectedPorts.forEach((port) => {
            port.postMessage(msg);
          });
        } catch (err) {
          console.log("app>ext", msg, err);
        }
        try {
          // chrome.tabs.sendMessage(tab.id, msg);
          connectedPagePorts.forEach((port) => {
            port.postMessage(msg);
          });
        } catch (err) {
          console.log("app>cms", msg, err);
        }
      } else {
        const port = pings[msg.index];
        if (connectedPorts.includes(port) || connectedPagePorts.includes(port))
          port.postMessage(msg);
      }
    });
  };

  const setIcon = (iconIndex = 1) => {
    iconIndex = parseInt(iconIndex);
    const path = chrome.runtime.getURL(`icons/icon${iconIndex}.svg`);
    // chrome.browserAction.setIcon({ path });
    const canvas = document.createElement("canvas");
    const ctx = canvas.getContext("2d");
    const img = new Image();
    img.onload = () => {
      const size = 16 * devicePixelRatio;
      ctx.drawImage(img, 0, 0, size, size);
      const imageData = ctx.getImageData(0, 0, size, size);
      chrome.browserAction.setIcon({ imageData });
    };
    img.src = path;

    chrome.browserAction.setBadgeBackgroundColor({
      color: iconIndex === 1 || iconIndex === 4 ? systemGrey3 : ninjaGreenLight,
    });
  };

  // Called when the user clicks on the browser action
  chrome.browserAction.onClicked.addListener((tab) => {
    if (!gaInit) {
      gaInit = true;
      ga("create", "UA-44169295-6", "auto"); // Replace with your property ID.
      ga("set", "checkProtocolTask", null);
      ga("require", "displayfeatures");
    }
    chrome.tabs.executeScript(tab.id, {
      file: "static/js/inject.js",
    });
    // connectedPorts.forEach(port => {
    //   port.postMessage({ type: "injectNinja", url: tab.url });
    // });
  });

  const onMessage = (port, context) => async (msg) => {
    const now = new Date().getTime();
    if (msg.type === "setIcon") {
      return setIcon(msg.iconIndex);
    }
    if (msg.type === "ping") {
      pings[msg.index] = port;
      port.postMessage({
        id: "fonts.ninja.ext.proxy",
        type: "pong",
        index: msg.index,
      });
      createNativePort();
    }
    if (msg.type === "installFamily" && now - lastNativeMsg > 1000) {
      installFamilyCache[msg.fontFamily] = msg.suggestionFamily;
    }
    if (msg.type === "gaEvent") {
      if (msg.env !== "production") return false;
      ga("send", "event", uaBrowser, msg.eventAction, msg.eventLabel || null, {
        nonInteraction: false,
      });
    }
    if (!nativePort) return;
    try {
      msg = Object.assign({ id: "fonts.ninja.ext.proxy" }, msg);
      if (!msg.type.match(/^p.ng$/) || msg.index < 10)
        console.log(context, msg);
      nativePort.postMessage(msg);
    } catch (err) {
      console.log(context, msg, err);
    }
  };

  chrome.runtime.onConnect.addListener((port) => {
    connectedPorts.push(port);
    port.onMessage.addListener(onMessage(port, "ext>app"));
    port.onDisconnect.addListener(() => {
      connectedPorts = connectedPorts.filter(
        (connectedPort) => connectedPort !== port
      );
    });
  });

  chrome.runtime.onConnectExternal.addListener((port) => {
    connectedPagePorts.push(port);
    port.onMessage.addListener(onMessage(port, "cms>app"));
    port.onDisconnect.addListener(() => {
      connectedPagePorts = connectedPagePorts.filter(
        (connectedPort) => connectedPort !== port
      );
    });
  });

  chrome.runtime.setUninstallURL("https://fontsninja.typeform.com/to/twfmuIFX");
  chrome.storage.sync.get("persist:settings", (json) => {
    const { iconIndex } = JSON.parse(json["persist:settings"] || "{}");
    setIcon(iconIndex);
  });

  chrome.runtime.onInstalled.addListener(({ reason }) => {
    // if (!notificationCheckerInterval) {
    //   notificationCheckerInterval = setInterval(notificationChecker, 180000);
    //   notificationChecker();
    // }
    if (reason !== "install") return;
    chrome.tabs.create({
      url: "https://overview.fonts.ninja/",
      active: true,
    });
  });

  const notificationChecker = () => {
    setTimeout(() => {
      chrome.storage.sync.get("persist:auth", async (json) => {
        const { authId, authToken } = JSON.parse(json["persist:auth"] || "{}");
        if (authId) {
          const res = await fetch("https://api.fonts.ninja/web/notification", {
            method: "GET",
            headers: new Headers({
              Authorization:
                "Basic " + btoa(JSON.parse(authId) + ":" + authToken),
              "Content-Type": "application/json",
            }),
          });
          const notifs = await res.json();
          let counter = notifs && notifs.length ? notifs[0].counter : 0;

          chrome.browserAction.setBadgeText({
            text: counter ? counter.toString() : "",
          });
          chrome.browserAction.setPopup({
            popup: counter
              ? "notifications.html?" + JSON.stringify(notifs[0])
              : "",
          });
        }
      });
    }, Math.random() * 60000);
  };
  chrome.browserAction.setPopup({ popup: "" });
  chrome.browserAction.setBadgeText({ text: "" });
  // chrome.alarms.create({ delayInMinutes: 240.0, periodInMinutes: 240.0 });
  // chrome.alarms.onAlarm.addListener(notificationChecker);
  // notificationChecker();
}
