chrome.browserAction.setPopup({ popup: "" });
chrome.browserAction.setBadgeText({ text: "" });

if (window.location.search.length) {
  const json = unescape(window.location.search.substr(1));
  const { id, icon, title, text, action } = JSON.parse(json);
  if (icon) {
    document.getElementById("icon").src = `notifications/icons/${icon}.svg`;
  }
  if (title) {
    document.getElementById("title").innerText = title;
  }
  if (text) {
    document.getElementById("text").innerText = text;
  }
  if (action) {
    document.getElementById(
      "action-icon"
    ).src = `notifications/actions/${action}.svg`;

    const text = action === "bookmarks" ? "Go to my bookmarks" : "";
    document.getElementById("action-text").innerText = text;

    document.getElementById("action").onclick = () => {
      chrome.tabs.query({ active: true, currentWindow: true }, ([tab]) => {
        chrome.tabs.executeScript(
          tab.id,
          {
            code: `window.ninjaAction = "${action}"`,
          },
          () => {
            chrome.tabs.executeScript(
              tab.id,
              {
                file: `static/js/inject.js`,
              },
              () => window.close()
            );
          }
        );
      });
    };
  }

  document.getElementById("ninja").onclick = () => {
    chrome.tabs.query({ active: true, currentWindow: true }, ([tab]) => {
      window.close();
      chrome.tabs.executeScript(tab.id, {
        file: "static/js/inject.js",
      });
    });
  };

  chrome.storage.sync.get("persist:auth", async (json) => {
    console.log(json);
    const { authId, authToken } = JSON.parse(json["persist:auth"] || "{}");
    if (authId) {
      const res = await fetch(
        `https://api.fonts.ninja/web/notification/${id}`,
        {
          method: "DELETE",
          headers: new Headers({
            Authorization:
              "Basic " + btoa(JSON.parse(authId) + ":" + authToken),
            "Content-Type": "application/json",
          }),
        }
      );
    }
  });
}
